import {RequestDecorator} from '../../../../common';

const WHITELISTED_METHODS = [
	'QUERY'
] as const;

export const decorateRequestWithMethod: RequestDecorator = (req) => {
	req.method = req.method?.trim().toUpperCase() ?? '';
	if (req.method === 'POST') {
		const spoofedMethod = req.headers['x-original-method'];
		if (Array.isArray(spoofedMethod)) {
			return req;
		}
		const whitelistedMethod = WHITELISTED_METHODS.find((s) => s === spoofedMethod);

		if (typeof whitelistedMethod === 'string') {
			req.method = whitelistedMethod;
		}
	}

	return req;
};
